//
//    Example 7-5.  
//
// : prog  
//
//  :
//   Learning OpenCV: Computer Vision with the OpenCV Library
//     by Gary Bradski and Adrian Kaehler
//     Published by O'Reilly Media, October 3, 2008

#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#include <stdio.h>

int main( int argc, char* argv[] )
{
	IplImage *src, *templ,*ftmp[6]; //ftmp is what to display on
	int i;

	char* filename = argc >= 2 ? argv[1] : "Image0.jpg";
	char* filename0 = argc >= 3 ? argv[2] : "templ.bmp";
	

	//  
	if((src=cvLoadImage(filename, 1))== 0) {
		printf("Error on reading src image %s\n",argv[1]);
		return(-1);
	}

	//  
	if((templ=cvLoadImage(filename0, 1))== 0) {
		printf("Error on reading template %s\n",argv[2]);
		return(-1);
	}
	
	int patchx = templ->width;
	int patchy = templ->height;
	int iwidth = src->width - patchx + 1;
	int iheight = src->height - patchy + 1;
	for(i=0; i<6; ++i){
		ftmp[i] = cvCreateImage( cvSize(iwidth,iheight),32,1);
	}

	//    
	for(i=0; i<6; ++i){
		cvMatchTemplate( src, templ, ftmp[i], i); 
		//		double min,max;
		//		cvMinMaxLoc(ftmp,&min,&max);
		cvNormalize(ftmp[i],ftmp[i],1,0,CV_MINMAX);
	}
	// 
	cvNamedWindow( "Template");
	cvShowImage(   "Template", templ );
	cvNamedWindow( "Image");
	cvShowImage(   "Image", src );

	cvNamedWindow( "SQDIFF" );
	cvShowImage( "SQDIFF", ftmp[0] );

	cvNamedWindow( "SQDIFF_NORMED" );
	cvShowImage(   "SQDIFF_NORMED", ftmp[1] );

	cvNamedWindow( "CCORR" );
	cvShowImage(   "CCORR", ftmp[2] );

	cvNamedWindow( "CCORR_NORMED" );
	cvShowImage(   "CCORR_NORMED", ftmp[3] );

	cvNamedWindow( "CCOEFF" );
	cvShowImage(   "CCOEFF", ftmp[4] );

	cvNamedWindow( "CCOEFF_NORMED" );
	cvShowImage(   "CCOEFF_NORMED", ftmp[5] );

	//   
	cvWaitKey(0);
	return 0;
} 
